using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Utilities.ProgramResource.Cqrs;

public record DeleteProgramResourceCommand(string Id) : IRequest<bool>;

public class DeleteProgramResourceHandler : IRequestHandler<DeleteProgramResourceCommand, bool>
{
    private readonly AppDbContext _context;

    public DeleteProgramResourceHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeleteProgramResourceCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.ProgramManagerResource
            .FirstOrDefaultAsync(x => x.Id == request.Id, cancellationToken);

        if (entity == null)
        {
            return false;
        }

        _context.ProgramManagerResource.Remove(entity);
        await _context.SaveChangesAsync(cancellationToken);

        return true;
    }
}